/*
  2014-2015 TEI3M RSGC ACES
  Gecko Firmware
  Original Author: Jackson Russett (Feb 2015)
  Maintenance Log...
  Revision: C. D'Arcy (Nov 2020) Corrected Adjustment using time_t timeStamp
  Revision: C. D'Arcy (Oct 2020) EST/EDT Updates until 2029
  Revision: C. D'Arcy (Jan 2018) EST/EDT Updates
  Revision: C. D'Arcy (Apr 2015) EST/EDT Change
  Revision: C. D'Arcy (May 2015) RSGC Academic Day Numbers
  Revision: C. D'Arcy (Jun 2015) Substitute H for 9
  Revision: C. D'Arcy (Sep 2015) 2015/2016 RSGC Day Numbers
  Revision: C. D'Arcy (Oct 2015) Fixed Oct-Dec Month Display
  Revision: P. Bagga  (Nov 2015) Added brightness setting for blue displays with clear plates
*/
#include <Wire.h>
//#include "RTClib.h"
//#include <RTC_DS1307.h>
#include <DS1307RTC.h>
#include "Adafruit_LEDBackpack.h"
#include "Adafruit_GFX.h"
//#include "Adafruit_MCP9808.h"
Adafruit_7segment matrix = Adafruit_7segment();
//Adafruit_MCP9808 tempsensor = Adafruit_MCP9808();
//RTC_DS1307 RTC;
//DS1307RTC RTC;
//DateTime now;
tmElements_t tm;
int delayTime = 3000;
boolean drawDots = false;
int degreeSign = 11111011;
int H = 72;
boolean tempFound = true;
//-----------------------------------------------------------------
// Bit mask codes. These can be used with writeDigitRaw to
// print various letters and symbols in a digit on the
// seven segment LED display.
// The first argument is the position
// on the 4-digit display, starting at 0 (far left),
// ending at 4 (far right), with position 2 being
// the colon (so you'll skip this position usually).
// The second argument is an integer that corresponds
// to the binary representation of the combination of
// 7 segments making up each digit.
//         0
//      ------
//   5  |     | 1
//      |  6  |
//      ------
//   4  |     | 2
//      |     |
//      ------   o7
//         3
// For example, to make upper case A, you want to
// light up segments 0,1,2,4,5,6.
// The binary representation would be b01110111.
//           The bit positions are -->b76543210
// The corresponding integer value is 119 for A.
// Use a binary-to-decimal calculator to convert.
// Below is a list of codes for letters and symbols
//  sevenseg.writeDigitRaw(0,119); // 119 = "A"
//  sevenseg.writeDigitRaw(0,124); // 124 = "b"
//  sevenseg.writeDigitRaw(0,57); // 57 = "C"
//  sevenseg.writeDigitRaw(0,94); // 94 = "d"
//  sevenseg.writeDigitRaw(0,121); // 121 = "E"
//  sevenseg.writeDigitRaw(0,113); // 113  = "F"
//  sevenseg.writeDigitRaw(0,125); // 125 = "G"
//  sevenseg.writeDigitRaw(0,118); // 118 = "H"
//  sevenseg.writeDigitRaw(0,116); // 116 = "h"
//  sevenseg.writeDigitRaw(0,6); // 6 = "I" aka 1
//  sevenseg.writeDigitRaw(0,4); // 4 = "i"
//  sevenseg.writeDigitRaw(0,30); // 30 = "J"
//  sevenseg.writeDigitRaw(0,56); // 56 = "L"
//  sevenseg.writeDigitRaw(0,84); // 84 = "n"
//  sevenseg.writeDigitRaw(0,92); // 92 = "o"
//  sevenseg.writeDigitRaw(0,115); // 115 = "P"
//  sevenseg.writeDigitRaw(0,103); // 103 = "q" aka 9
//  sevenseg.writeDigitRaw(0,80); // 80 = "r"
//  sevenseg.writeDigitRaw(0,109); // 109 = "S" aka 5
//  sevenseg.writeDigitRaw(0,70); // 70 = "t"
//  sevenseg.writeDigitRaw(0,28); // 28 = "u"
//  sevenseg.writeDigitRaw(0,62); // 62 = "U"
//  sevenseg.writeDigitRaw(0,110); // 110 = "y"
//  sevenseg.writeDigitRaw(0,64); // 64 = "-" negative sign
//  sevenseg.writeDigitRaw(0,34); // 34 = " " " double quote
//  sevenseg.writeDigitRaw(0,32); // 32 = "'" apostrophe (upper left)
//  sevenseg.writeDigitRaw(0,2); // 2 = "'" apostrophe (upper right)
//  sevenseg.writeDigitRaw(0,8); // 8 = "_" underscore
//  sevenseg.writeDigitRaw(0,1); // 1 = "-" overbar
//  sevenseg.writeDigitRaw(0,16); // 16 = lower left bar
//  sevenseg.writeDigitRaw(0,4); // 4 = lower right bar
//  sevenseg.writeDigitRaw(0,128); // 128 = "." decimal
//  sevenseg.writeDigitRaw(0,0); // blank
//  sevenseg.writeDigitRaw(2,255); // 255 = ":"  colon, always position 2
/**********************************************************************************
   Always follow a writeDigitRaw command with the
   writeDisplay(); command to push the data to the
   display.
***********************************************************************************/
// ------------------------2017/2018 Day Calendar----------------------------------
int schoolYear[12][32] = {
  /*  {9, 9, 9, 9, 9, 9, 9, 9, 0, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2, 3, 4}, //january
    {9, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 9, 9, 9, 9, 4, 1, 2, 3, 9, 9, 4, 1, 2}, //february
    {9, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 2, 3, 4, 5, 9, 9}, //march
    {9, 9, 9, 6, 7, 8, 1, 9, 9, 2, 3, 4, 5, 6, 9, 9, 7, 8, 1, 2, 3, 9, 9, 4, 5, 6, 7, 8, 9, 9, 1}, //april
    {9, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 9, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3}, // may
    {9, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, //june
    {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, // july
    {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, //august
    {9, 9, 9, 9, 9, 9, 0, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 9, 9, 9, 4, 1, 2, 3, 4, 9}, // september
    {9, 9, 1, 2, 3, 4, 1, 9, 9, 9, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1}, //october
    {9, 2, 3, 4, 9, 9, 1, 2, 3, 4, 9, 9, 9, 9, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1}, //november
    {9, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9} //december
    };*/ // Day Calendar 2018 - 2019
  {9, 9, 9, 9, 9, 9, 9, 0, 8, 1, 2, 3, 9, 9, 4, 5, 6, 7, 8, 9, 9, 1, 2, 3, 4, 5, 9, 9, 6, 7, 8, 1}, //january
  {9, 2, 9, 9, 3, 4, 5, 6, 7, 9, 9, 8, 1, 2, 3, 9, 9, 9, 9, 4, 5, 6, 7, 9, 9, 8, 1, 2, 3}, //february
  {9, 4, 9, 9, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 1, 2, 3, 4, 9, 9, 5, 6}, //march
  {9, 5, 6, 7, 8, 1, 9, 9, 2, 3, 4, 5, 6, 9, 9, 7, 8, 1, 2, 9, 9, 9, 9, 3, 4, 5, 6, 9, 9, 7, 8}, //april
  {9, 1, 2, 3, 9, 9, 4, 5, 6, 7, 8, 9, 9, 1, 2, 3, 4, 5, 9, 9, 9, 6, 7, 8, 1, 9, 9, 2, 3, 4, 5, 6}, // may
  {9, 9, 9, 7, 8, 1, 2, 3, 9, 9, 4, 5, 6, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, //june
  {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, // july
  {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}, //august
  {9, 9, 9, 9, 9, 0, 1, 2, 9, 9, 3, 4, 5, 6, 7, 9, 9, 8, 1, 2, 3, 0, 9, 9, 4, 5, 6, 7, 8, 9, 9}, // september
  {9, 1, 2, 3, 4, 5, 9, 9, 9, 6, 7, 8, 1, 9, 9, 2, 3, 4, 5, 6, 9, 9, 7, 8, 1, 2, 3, 9, 9, 4, 5, 6}, //october
  {9, 7, 8, 9, 9, 1, 2, 3, 4, 9, 9, 9, 9, 5, 6, 7, 8, 9, 9, 1, 2, 3, 4, 5, 9, 9, 6, 7, 8, 1, 2}, //november
  {9, 9, 9, 3, 4, 5, 6, 7, 9, 9, 8, 1, 2, 3, 4, 9, 9, 5, 6, 7, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9} //december
};
// --------------------------------------------------------------------------------
// Added to account for EST/EDT changes Toronto
// Resource:  http://www.epochconverter.com/
// Reference:  http://www.timeanddate.com/time/zone/canada/toronto
unsigned long UTCs[] = {
/*  1583647200L, /*Sun, Mar 8 2020 at 2:00 am*/
/*  1604214000L, /*Sun, Nov 1 2020 at 2:00 am*/
/*  1615705200L, /*Sun, Mar 14 2021 at 2:00 am*/
/*  1636268400L, /*Sun, Nov 7 2021 at 2:00 am*/
/*  1647154800L, /*Sun, Mar 13 2022 at 2:00 am*/
/*  1667718000L, /*Sun, Nov 6 2022 at 2:00 am*/
/*  1678604400L, /*Sun, Mar 12 2023 at 2:00 am*/
/*  1699167600L, /*Sun, Nov 5 2023 at 2:00 am*/
  1710054000L, /*Sun, Mar 10 2024 at 2:00 am*/
  1730617200L, /*Sun, Nov 3 2024 at 2:00 am*/
  1741503600L, /*Sun, Mar 9 2025 at 2:00 am*/
  1762066800L, /*Sun, Nov 2 2025 at 2:00 am*/
  1772953200L, /*Sun, Mar 8 2026 at 2:00 am*/
  1793516400L, /*Sun, Nov 1 2026 at 2:00 am*/
  1805007600L, /*Sun, Mar 14 2027 at 2:00 am*/
  1825570800L, /*Sun, Nov 7 2027 at 2:00 am*/
  1836457200L, /*Sun, Mar 12 2028 at 2:00 am*/
  1857020400L, /*Sun, Nov 5 2028 at 2:00 am*/
  1867906800L, /*Sun, Mar 11 2029 at 2:00 am*/
  1888470000L, /*Sun, Nov 4 2029 at 2:00 am*/
};
// ---------------------------------------------------------------
void setup() {
  //Activate next four lines for testing if RTC placed in A2-A5...
  //  pinMode(A2, OUTPUT);
  //  pinMode(A3, OUTPUT);
  //  digitalWrite(A2, LOW);
  //  digitalWrite(A3, HIGH);
  //  Serial.begin(9600);
  matrix.begin(0x70);
  Wire.begin();
//  if (!tempsensor.begin()) {
    // Serial.println("Couldn't find MCP9808!");
//    tempFound = false;
//  }
  //for blue and clear displays
  //
  matrix.setBrightness(1);  //0: off  15: maximum
}

void loop() {
  //  Serial.println("Time");
  for (int i = 0; i < 4; i++)
    showTime();
  //showDate();
  //  Serial.println(tm.Month);
  //  Serial.println(tm.Day);
  //  Serial.println(tm.Year+1970);
  //Serial.println("Temp");
  //if (tempFound) showTemp();
  //  showDayNum();
}

// Added May 12, 2015 to determine time adjustment as a result of EST > EDT > EST...
//int getAdjustment(unsigned long currentTime) {
int getAdjustment() {
  int i = 0;
  //Ref:https://arduino.stackexchange.com/questions/69618/converting-human-readable-date-to-a-unix-timestamp
  time_t unix_timestamp = makeTime(tm); // a timestamp
  //Serial.println(unix_timestamp);
  //  while (currentTime > UTCs[i + 1])
  while (unix_timestamp > UTCs[i])
    i++;
  // Time based on EST RTC Setting
  // index is either even (EST: no adjustment) or odd (DST: add 1)
  return (i % 2);
}

void showTime() {
  //    now = RTC.now();
  RTC.read(tm);
  // Serial.println(tm.Hour);

  // ---------Jackson's original statements --------
  //matrix.print((now.hour() * 100) + now.minute());
  //if (now.hour() < 10) {
  //  matrix.writeDigitNum(0, 0);
  //}
  //------------------------------------------------
  //== Modified to account for EST > DST > EST...===
  //    int adjustment = getAdjustment(now.unixtime());
  //    int adjustment = getAdjustment(now());
  int adjustment = getAdjustment();
  //    int hourAdj = ((now.hour() + adjustment) % 12);
  int hourAdj = ((tm.Hour + adjustment) % 12);
  if (hourAdj == 0) hourAdj = 12;
  //    matrix.print( hourAdj * 100 + now.minute());
  // Serial.println(hourAdj);
  matrix.print( hourAdj * 100 + tm.Minute);
  //================================================

  switching();
  matrix.drawColon(drawDots);
  matrix.writeDisplay();
  delay(delayTime >> 2);
  switching();
  matrix.drawColon(drawDots);
  matrix.writeDisplay();
  delay(delayTime >> 2);
}

void switching() {
  drawDots = !drawDots;
}

void showTemp() {
//  float c = tempsensor.readTempC();
//  matrix.print(c - 3.8); //Adjusted
  matrix.writeDigitRaw(4, degreeSign);
  matrix.writeDisplay();
  delay(delayTime >> 1);
}

void showDayNum() {
  int thisMonth = tm.Month;
  int thisDay = tm.Day;
  matrix.writeDigitRaw(0, 94);
  matrix.writeDigitRaw(1, 119);
  matrix.writeDigitRaw(3, 0b01101110);
  int dayNum = schoolYear[thisMonth - 1][thisDay];
  if (dayNum == 9)
    matrix.writeDigitRaw(4, 118);  // 'H' - 118
  else
    matrix.writeDigitNum(4, dayNum);
  matrix.writeDisplay();
  delay(delayTime >> 2);
}

void showDate() {
  // now = RTC.now();
  RTC.read(tm);
  //Serial.println(now.unixtime());
  int thisMonth = tm.Month;
  if (thisMonth < 10) {
    matrix.writeDigitNum(0, 0);
    matrix.writeDigitNum(1, tm.Month, true);
  } else {
    matrix.writeDigitNum(0, 1);
    matrix.writeDigitNum(1, thisMonth % 10, true);
  }
  matrix.writeDigitNum(3, tm.Day / 10);
  matrix.writeDigitNum(4, tm.Day % 10);
  matrix.writeDisplay();
  delay(delayTime >> 1);
  matrix.print(tm.Year + 1970);
  matrix.writeDisplay();
  delay(delayTime >> 1);
}
